//
// AquesTalk for Android sample program
//
// 2010/05/11 N.Yamazaki	Creation

package sample.aquest;

import android.app.Activity;
import android.os.Bundle;
import android.media.MediaPlayer;
import android.util.Log;
import android.widget.TextView;
import java.io.*;

import aquestalk.AquesTalk;	// AquesTalkクラス 別途libAquesTalk.soが必要


public class HelloAquesTalk extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        String koe = "ゆっくりしていってね？";
        // 音声合成
        AquesTalk aquestalk = new AquesTalk(AquesTalk.PRESET.F1);
        aquestalk.spd = 90;
        byte[] wav = aquestalk.synthe(koe);
//        byte[] wav = AquesTalk.syntheWav(koe, 2,100,100,100,100,100,100); // direct JNI call

    	if(wav.length==1){//生成エラー時には,長さ１で、先頭にエラーコードが返される
        	Log.v("AQTKAPP", "AquesTalk Synthe ERROR:"+wav[0]);
    	}
    	else {
    		PlayWav(wav);//音声データを再生出力
    	}

    	TextView textView = new TextView(this);
     	textView.setText("音声記号列："+koe);
     	setContentView(textView);
  }
  
  private void PlayWav(byte[] wav) {
	  // 一旦ファイルに出力してから、MediaPlayerで再生
	  String tmpfilename = "tmp_hello.wav";
	  String packagename = removeSuffix(this.getClass().getName());
	  
      try {
          FileOutputStream fileOutputStream = openFileOutput(tmpfilename, MODE_WORLD_READABLE);//MODE_PRIVATEはNG!
          fileOutputStream.write(wav);
          fileOutputStream.close();
      } catch (IOException e) {
    	  Log.e("AQTKAPP", "ERR: FileOutputStream");
      }
      try {
          MediaPlayer mp = new MediaPlayer();
      	  // mp.reset();	// MediaPlayerインスタンスを複数回使うときは必要
          mp.setDataSource("/data/data/"+packagename+"/files/"+tmpfilename);
          mp.prepare();	//<<忘れると動かない　(-38,0)のようなエラーがでる
          mp.start();   
		} catch (IOException e) {
		}
  }

  public static String removeSuffix(String fileName) {
	    if (fileName == null)
	        return null;
	    int point = fileName.lastIndexOf(".");
	    if (point != -1) {
	        return fileName.substring(0, point);
	    } 
	    return fileName;
	}
 
}